//
//  cntrlInspectionItemSpecItemTest.swift
//
//
//  Created by Michiel Carman on 2/16/24.
//


import Fluent
import Vapor
import Foundation
import FluentKit

final class mdlInspectionItemSpecItemTest: Model, Content {
    static let schema = "inspectionItemSpecItemTest"
    
    @ID(custom: "id", generatedBy: .database) var id: Int?
    @Parent(key: "inspectionItemSpecItemId") var specitem: mdlInspectionItemSpecItem
    @Field(key: "number") var number: Int?
    @Field(key: "value") var value: String?
    
    @Timestamp(key: "createDate", on: .create) var createdate: Date?
    @Field(key: "createUserId") var createuserid: Int?
    @Timestamp(key: "updateDate", on: .update) var updatedate: Date?
    @Field(key: "updateUserId") var updateuserid: Int?
    
    init() { }
    
    init(id: Int? = nil,
         specitemid: Int,
         number: Int? = nil,
         value: String? = nil,
         createuserid: Int? = nil,
         updateuserid: Int? = nil
    ) {
        self.id = id
        self.$specitem.$id.value = specitemid
        self.number = number
        self.value = value
        self.createuserid = createuserid
        self.updateuserid = updateuserid
    }
}
extension mdlInspectionItemSpecItemTest{
    struct Create: AsyncMigration {
        func prepare(on database: Database) async throws {
            try await database.schema("inspectionItemSpecItemTest")
                .field("id", .int, .identifier(auto: true))
                .field("inspectionItemSpecItemId", .int, .references("inspectionItemSpecItem", "id"))
                .field("number", .int)
                .field("value", .string)
                .field("createDate", .datetime)
                .field("createUserId", .int)
                .field("updateDate", .datetime)
                .field("updateUserId", .int)
                .create()
        }
        
        func revert(on database: Database) async throws {
            try await database.schema("inspectionItemSpecItemTest").delete()
        }
    }
    public static func ObjQuery(req: Request) async throws -> QueryBuilder<mdlInspectionItemSpecItemTest>{
        
        let query = mdlInspectionItemSpecItemTest.query(on: req.db)
            .with(\.$specitem)
        
        if let x = req.parameters.get("x"){
            let decryptedString = try CustomCrypto.DecryptString(input: x)
            let array =  decryptedString.components(separatedBy: ":")
            ///This call is the standard get by id call
            if (array.count == 1){
                let id = Int(array[0])!
                return query.filter(\.$id == id)
            }
            ///Optional else if if there are multiple parameters in the call
            ///You must include an else for each call that has parameters
            ///Need to check the endpoint to get the right filter statements
            ///else if(x.count == 2){
            ///    let username = x[0]
            ///    let password = x[1]
            ///    return query.filter(\.$username == username).filter(\.$password == password)
            ///}
            else{
                throw Abort(.badRequest)
            }
            
        }
        else{
            return query
        }
    }
}

